#include "C55_CSS.h"





void initlcd(void);               // Initializes the LCD.
void writecom(char);            // Writes a command.
void writedata(char);            // Writes data to DDRAM to illuminate the pixels.
void clockdata(char);            // Clocks in data into the PCD8544 controller.
void clearram(void);            // Erase the DDRAM contents.
void cursorxy(char,char);         // Position cursor to x,y.
void putchar(int,char,char);               // (  ),x,y-

void writedata_simvol(char);
void clockdata_simvol(char);

const char table[250] = {0x00,0x00,0x00,0x04,0x08,0x1f,0x00,0x00,0x00,0x00,
                   0x00,0x00,0x00,0x02,0x02,0xfe,0x02,0x02,0x00,0x00,      // 1-0



};                   

//      ,  36 ,
//    2    
//   0.0   |   0.1   |   0.2   |   0.3   |   0.4   |   0.5   |   0.6   |   0.7   |   0.8   |
//      |      |      |      |      |      |      |      |      |
//-----------------------------------------------------------------------
//   1.0   |   1.1   |   1.2   |   1.3   |   1.4   |   1.5   |   1.6   |   1.7   |   1.8   |
//      |      |      |      |      |      |      |      |      |
//-----------------------------------------------------------------------
//   2.0   |   2.1   |   2.2   |   2.3   |   2.4   |   2.5   |   2.6   |   2.7   |   2.8   |
//      |      |      |      |      |      |      |      |      |
//-----------------------------------------------------------------------
//   3.0   |   3.1   |   3.2   |   3.3   |   3.4   |   3.5   |   3.6   |   3.7   |   3.8   |
//      |      |      |      |      |      |      |      |      |
//
// 0.0- 1 y=0,x=0;2 y=1,x=0
// 0.1- 1 y=0,x=11;2 y=1,x=11
// 0.2- 1 y=0,x=21;2 y=1,x=21
// 0.3- 1 y=0,x=31;2 y=1,x=31
// 0.4- 1 y=0,x=41;2 y=1,x=41
// 0.5- 1 y=0,x=51;2 y=1,x=51
// 0.6- 1 y=0,x=61;2 y=1,x=61
// 0.7- 1 y=0,x=71;2 y=1,x=71
// 0.8- 1 y=0,x=81;2 y=1,x=81
//
// 1.0- 1 y=2,x=0;2 y=3,x=0
// 1.1- 1 y=2,x=11;2 y=3,x=11
// 1.2- 1 y=2,x=21;2 y=3,x=21
// 1.3- 1 y=2,x=31;2 y=3,x=31
// 1.4- 1 y=2,x=41;2 y=3,x=41
// 1.5- 1 y=2,x=51;2 y=3,x=51
// 1.6- 1 y=2,x=61;2 y=3,x=61
// 1.7- 1 y=2,x=71;2 y=3,x=71
// 1.8- 1 y=2,x=81;2 y=3,x=81
//
// 2.0- 1 y=4,x=0;2 y=5,x=0
// 2.1- 1 y=4,x=11;2 y=5,x=11
// 2.2- 1 y=4,x=21;2 y=5,x=21
// 2.3- 1 y=4,x=31;2 y=5,x=31
// 2.4- 1 y=4,x=41;2 y=5,x=41
// 2.5- 1 y=4,x=51;2 y=5,x=51
// 2.6- 1 y=4,x=61;2 y=5,x=61
// 2.7- 1 y=4,x=71;2 y=5,x=71
// 2.8- 1 y=4,x=81;2 y=5,x=81
//
// 3.0- 1 y=6,x=0;2 y=7,x=0
// 3.1- 1 y=6,x=11;2 y=7,x=11
// 3.2- 1 y=6,x=21;2 y=7,x=21
// 3.3- 1 y=6,x=31;2 y=7,x=31
// 3.4- 1 y=6,x=41;2 y=7,x=41
// 3.5- 1 y=6,x=51;2 y=7,x=51
// 3.6- 1 y=6,x=61;2 y=7,x=61
// 3.7- 1 y=6,x=71;2 y=7,x=71
// 3.8- 1 y=6,x=81;2 y=7,x=81

//  1-0,2-20,3-40,4-60,5-80,6-100,7-120,8-140,9-160,0-180
//-200,-220,-240,-260,-280,-300,-320,-340,-360,-380,-400,-420,-440,-460,-480
//-500,-520,-540,-560,-580,-600,-620,-640,-660,-680,-700,-720,-740,-760,-780
//U-800,I-820,=-840
void main()
{
   int i;
   
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_1);
   setup_wdt(WDT_18MS);
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DISABLED,0,1);
   setup_comparator(NC_NC_NC_NC);
   setup_vref(FALSE);
   
   

    set_tris_B(0x00);   
    output_B(0x00);
   initlcd();
while(1)
{

   putchar(0,0,0);  
   
}
for(;;)
   {
   
   }

}

void initlcd(void)
{
   output_high(_RES);      // Set _RES HIGH.
   output_high(_SCE);      // Disable Chip.
   output_low(_RES);      // Reset the LCD.
   delay_ms(100);   // Wait 100ms.
   output_high(_RES);      // Awake LCD from RESET state.

   writecom(0x21);      // Activate Chip and H=1.
   writecom(0xC0);      // Set LCD Voltage to about 7V.
   writecom(0x12);      // Adjust voltage bias.
   writecom(0x20);      // Horizontal addressing and H=0.
   writecom(0x09);      // Activate all segments.
   clearram();         // Erase all pixel on the DDRAM.
   writecom(0x08);      // Blank the Display.
   writecom(0x0C);      // Display Normal.
   cursorxy(0,0);      // Cursor Home.
}
//**********************************************************************
void writecom(char command_in)
{
   output_low(D_C);            // Select Command register.
   output_low(_SCE);            // Select Chip.
   clockdata(command_in);   // Clock in command bits.
   output_high(_SCE);            // Deselect Chip.   
}
//**********************************************************************
void writedata(char data_in)
{
   output_high(D_C);            // Select Data register.
   output_low(_SCE);            // Select Chip.
   clockdata(data_in);      // Clock in data bits.
   output_high(_SCE);            // Deselect Chip.   
}
//***************************************************************************************************************
void clockdata(char bits_in)
{
   int bitcnt;
   for (bitcnt=8; bitcnt>0; bitcnt--)
      {
         output_low(SCK);                        // Set Clock Idle level LOW.
         if ((bits_in&0x80)==0x80) {output_high(SDI);}      // PCD8544 clocks in the MSb first.
         else {output_low(SDI);}
         output_high(SCK);                        // Data is clocked on the rising edge of SCK.
         bits_in=bits_in<<1;                  // Logical shift data by 1 bit left.
      }
}
//****************************************************************************************************************
void clearram(void)
{
   int ddram;
   cursorxy(0,0);                                 // Cursor Home.
   for (ddram=918;ddram>0;ddram--)   {writedata(0x00);}      // 6*84 = 504 DDRAM addresses.
}
//****************************************************************************************************************   

void cursorxy(char x, char y)
{
    x=x*10;
   y=y<<1;
   writecom(0x40|(y&0x0f));   // Y axis
   writecom(0x80|(x&0x7f));   // X axis
}
//****************************************************************************************************************
void putchar(int character,char x,char y)
{
   int tablept, count, char_column;

   if ((character<0)||(character>860)) {return;}      // Exit function if character is not found.
   
   cursorxy(x,y);               
    tablept=character;
   for (count=10;count>0;count--)                     // Draw the columns to print the character.
   {
      char_column = table[tablept];
      writedata_simvol(char_column);
      tablept++;
   }
   
   y=(y<<1)+1;
   x=x*10;
   writecom(0x40|(y&0x0f));   // Y axis
   writecom(0x80|(x&0x7f));   // X axis
    
   for (count=10;count>0;count--)                     // Draw the columns to print the character.
   {
      char_column = table[tablept];
      writedata_simvol(char_column);
      tablept++;
   }
}

//***************************************************************************************************************
void clockdata_simvol(char bits_in)
{
   int bitcnt;
   for (bitcnt=8; bitcnt>0; bitcnt--)
      {
         output_low(SCK);                        // Set Clock Idle level LOW.
         if ((bits_in&0x80)==0x80) {output_high(SDI);}      // PCD8544 clocks in the MSb first.
         else {output_low(SDI);}
         output_high(SCK);                        // Data is clocked on the rising edge of SCK.
         bits_in=bits_in<<1;                  // Logical shift data by 1 bit left.
      }
}

void writedata_simvol(char data)
{
   output_high(D_C);            // Select Data register.
   output_low(_SCE);            // Select Chip.
   clockdata_simvol(data);      // Clock in data bits.
   output_high(_SCE);            // Deselect Chip.   
}
